program Compress;

uses TClass;

var Data:array [0..16383] of Byte;
    OPtr,DPtr:Word;
	i,n:Integer;
	f:File of Byte;
	Lvl:TLevel;
	Percent:Real;

procedure CompressLevel(var Lvl:TLevel);
var Total,n,b,x,y:Integer;
begin
	x := 0;y := 0;						{ Start position }
	Total := 0;
	while y <> 24 do					{ Compress until the end }
		begin
			n := 0;						{ Count identicals }
			b := Lvl.Map[x,y];
			while (y <> 24) and (Lvl.Map[x,y] = b) and (n < 15) do
				begin
					Inc(n);x := (x + 1) mod 32;
					if x = 0 then Inc(y);
				end;
			Total := Total + n;			{ Final total }
			Data[DPtr] := n * 16 + b;	{ Write the RLE data out }
			Inc(DPtr);
		end;
	if Total <> 32*24 then				{ Check right number of bytes }
		WriteLn('Compression Error');
	Data[DPtr] := 0;Inc(DPtr);			{ Add 'end of compression' byte }
end;

begin
	WriteLn;WriteLn('Splat! RLE Level Compressor');WriteLn;
	for i := 0 to 16383 do Data[i] := $FF;

	Data[0] := 0;			{ 0 Levels compressed so far }
	Data[1] := 0;

	DPtr := 32;				{ Allows for 15 levels maximum compressed }
	n := 1;
	repeat
		Lvl.Init;						{ Erase level }
		Lvl.Load(n);					{ Read the level }
		if not Lvl.NewFile then
			begin
				WriteLn('Compressing Level ',n);
				OPtr := DPtr;			{ Remember original position }
                Data[n * 2] := OPtr and $FF;
				Data[n * 2 + 1] := OPtr div 256;
				Data[0] := n;
				CompressLevel(Lvl);		{ Compress the data }
				Percent := (DPtr - OPtr) / (32.0*24.0) * 100.0;
				WriteLn('     Now ',DPtr-OPtr,' bytes (',Percent:6:1,'%).');
				Inc(n);
			end;
	until Lvl.NewFile;
	WriteLn;WriteLn('Complete file is ',DPtr,' bytes in length.');
	Assign(f,'LEVELS.BIN');
	Rewrite(f);
	for i := 0 to DPtr-1 do Write(f,Data[i]);
	Close(f);
end.