(************************************************************************)
(*																		*)
(*					Group for the whole display							*)
(*																		*)
(************************************************************************)

unit	GuiMain;

interface

uses	GuiObj,GuiMap,TClass;

type	TGuiDisplay = object(TGroup)		{ Main display object }
	Tiles:PTileSet;
	ME:PMapEditor;
	constructor Init;
	destructor  Done;
	procedure	CopyIn(var r:TLevel);
	procedure	Extract(var r:TLevel);
	procedure	AddWithLabel(p:PGuiObject;s:String);
end;

type  	PGuiDisplay = ^TGuiDisplay;

implementation

uses Graph;

(************************************)
(*	Create a Main Display Object	*)
(************************************)

constructor	TGuiDisplay.Init;
var Sel:PTileSelector;
begin
	New(Tiles,Init);
	TGroup.Init;
	New(Sel,Init(340,72,Tiles));
	Add(Sel);
	ME := New(PMapEditor,Init(20,140,1,Sel));
	Add(ME);
end;

(************************************)
(*  Delete a main display object	*)
(************************************)

destructor  TGuiDisplay.Done;
begin
	Dispose(Tiles,Done);
	TGroup.Done;
end;

(************************************************)
(*	Add an object, with an associated label 	*)
(************************************************)

procedure	TGuiDisplay.AddWithLabel(p:PGuiObject;s:String);
begin
	Add(p);
	Add(New(PText,Init(p^.OrgX-(TextWidth(s)+10),p^.OrgY,Concat(s,':'))));
end;

(****************************************)
(*	Copy Room data into GUI Objects		*)
(****************************************)

procedure	TGuiDisplay.CopyIn(var r:TLevel);
begin
	ME^.Map := r.Map;
end;

(****************************************)
(*	Copy GUI Objects into Room Record	*)
(****************************************)

procedure	TGuiDisplay.Extract(var r:TLevel);
var i:Integer;
begin
	r.Map := ME^.Map;

end;

begin
end.