(********************************************************************)
(*																	*)
(*						Map Editor GUI Class						*)
(*																	*)
(********************************************************************)

unit GuiMap;

interface

uses TClass,GuiObj;

type TMapEditor = object(TGuiObject)
	Scale:Integer;
	Selector:PTileSelector;
	OType:Integer;
	Map:TMap;
	constructor Init(x,y,s:Integer;TS:PTileSelector);
	procedure	Paint;virtual;
	procedure	Refresh(x,y:Integer);
	procedure	Click(x,y:Integer);virtual;
end;

type PMapEditor = ^TMapEditor;

implementation

uses Graph,Video;

constructor TMapEditor.Init(x,y,s:Integer;TS:PTileSelector);
var x1,y1:Integer;
begin
	Selector := TS;
	Scale := s;
	for x1 := 0 to 31 do
		for y1 := 0 to 23 do
			Map[x1,y1] := 0;
	TGuiObject.Init(x,y,s*32*8+35,s*24*8+27);
end;

procedure	TMapEditor.Paint;
var x,y:Integer;
begin
	Box3D(Left,Top,Right,Bottom,True);
	for x := 0 to 31 do
		for y := 0 to 23 do
					Refresh(x,y);
end;

procedure	TMapEditor.Refresh(x,y:Integer);
var c,n:Integer;
begin
	n := Map[x,y];
	x := x*8*Scale+2+Left+x;
	y := y*8*Scale+2+Top+y;
	c := Green;
    Selector^.Tiles^.Tile[n and 63].Draw(x,y,Scale,c);
end;

procedure	TMapEditor.Click(x,y:Integer);
begin
	x := (x-2) div (8*Scale+1);
	y := (y-2) div (8*Scale+1);
    if x > 31 then x := 31;
	if y > 23  then y := 23;
	Map[x,y] := Selector^.Selected;
	Refresh(x,y);
end;

begin
end.


